// T13_SER04.C
// 10.07.2012

#include <avr/io.h>

unsigned char n,A_Reg,c,E_Reg; // AD_Wert,i;

void warte()
{
for (n=0;n<7;n++);  // 1 Bitlaenge
}

void WrCOM()
{

PORTB |=(1<<PB1);    // TXD = 1
warte();

for (c=0;c<8;c++)
{
if((E_Reg & 1)==0)
{
PORTB |=(1<<PB1);    // TXD = 1   
}
else
{
PORTB &=~(1<<PB1);   // TXD = 0
}
warte();
E_Reg=E_Reg>>1;
}
PORTB &=~(1<<PB1);   // TXD = 0
warte();
}

void RdCOM()
{
while((PINB & 4)==0);
for(n=0;n<14;n++);   // 1,5 Bit Wartezeit
E_Reg=0;
for(c=0;c<8;c++)
{
E_Reg=E_Reg>>1;
if((PINB & 4)==4) 
{
E_Reg=E_Reg|128;
}
warte();
}
warte();
E_Reg =~E_Reg;      // oder: E_Reg=255-E_Reg;
}

ADC_Init()
{
ADMUX  |= (1<<ADLAR) ; // 8-Bit-Messung 
		ADCSRA =(1<<ADEN)| (1<<ADPS1)|(1<<ADPS0); //  ADC ein, Clock / 8 
}

RdADC()
{
		ADCSRA |= (1<<ADSC);        // Einzelne AD-Wandlung starten
		while(ADCSRA & (1<<ADSC));  //  warten, bis AD-Wandlung abgeschlossen     
		E_Reg=ADCH;                 // Inhalt von ADCH nach E_Reg
		E_Reg=ADCH;
}

void PWM_Init()
{
TCCR0A=0b10000011;
TCCR0B=0b00000010;
}

void main()
{

DDRB=0b00001011;// PB5: Eingang (ADC0, RESET) PB2: Eingang(RXD)
                // PB0:Ausgang, PB3: Ausgang, PB4: Eingang(ADC2)

//E_Reg=85;      // Test, 
//WrCOM();       // kann entfallen

ADC_Init();

while(1)

{
A_Reg=0;
RdCOM();

A_Reg=E_Reg;

switch (A_Reg)
{
case 1:        // PWM 
PWM_Init();
RdCOM();
OCR0A=E_Reg;
break;

case 2:       
ADMUX |= (1<<MUX1);  // MUX1 setzen
RdADC();  // ADC2 lesen
WrCOM();
break;

case 3:
PORTB |=(1<< PB3);   // PB3 setzen
break;

case 4:
PORTB &=~(1<<PB3);   // PB3 zuruecksetzen
break;

case 5:       
ADMUX &= ~(1<<MUX1); // MUX1 loeschen
RdADC();  // ADC0 lesen
WrCOM();
break;

default:
break;

}
}
}
